
#
# BioPerl module for Bio::Annotation::DBLink
#
# Cared for by Ewan Birney <pfam@sanger.ac.uk>
#
# Copyright Ewan Birney
#
# You may distribute this module under the same terms as perl itself

# POD documentation - main docs before the code

=head1 NAME

Bio::Annotation::DBLink - DESCRIPTION of Object

=head1 SYNOPSIS

Give standard usage here

=head1 DESCRIPTION

Describe the object here

=head1 CONTACT

Describe contact details here

=head1 APPENDIX

The rest of the documentation details each of the object methods. Internal methods are usually preceded with a _

=cut


# Let the code begin...


package Bio::Annotation::DBLink;
use vars qw($AUTOLOAD @ISA);
use strict;

# Object preamble - inheriets from Bio::Root::Object

use Bio::Root::Object;


@ISA = qw(Bio::Root::Object Exporter);
# new() is inherited from Bio::Root::Object

# _initialize is where the heavy stuff will happen when new is called

sub _initialize {
  my($self,@args) = @_;

  my $make = $self->SUPER::_initialize;

  $self->{'additional'} = [];

# set stuff in self from @args
 return $make; # success - we hope!
}



=head2 add_additional

 Title   : add_additional
    Usage   : $link->add_addtional("fa");
 Function: 
    To add additional information to the link
 Returns : 
 Args    : newvalue (optional)


=cut

sub add_additional {
   my ($self,$value) = @_;

   push (@{$self->{'additional'}}, $value);   
}




=head2 each_additional

 Title   : start
 Usage   : @arr = $link->each_additional();
 Function: 
    Some links (e.g. PDB, SCOP), have extra information.
    Here is a way of getting at it. this information
    is database dependent so should be used with care

 Returns : 
 Args    : newvalue (optional)


=cut

sub each_additional {
   my ($self,$value) = @_;

   return (@{$self->{'additional'}});   
}




=head2 database

 Title   : database
 Usage   : $self->database($newval)
 Function: 
 Example : 
 Returns : value of database
 Args    : newvalue (optional)


=cut

sub database{
   my ($self,$value) = @_;
   if( defined $value) {
      $self->{'database'} = $value;
    }
    return $self->{'database'};

}


=head2 optional_id

 Title   : optiona_id
 Usage   : $self->optional_id($newval)
 Function: 
 Example : 
 Returns : value of primary_id
 Args    : newvalue (optional)
 Notes: 
    This method has been deprecated

=cut

sub optional_id{
   my ($self,$value) = @_;

   my $error_string = "Bio::Annotation::DBLink->optional_id has been deprecated.";
   $error_string .= "Use add_additional and each_additional instead";
   
   $self->throw( $error_string );
}




=head2 primary_id

 Title   : primary_id
 Usage   : $self->primary_id($newval)
 Function: 
 Example : 
 Returns : value of primary_id
 Args    : newvalue (optional)


=cut

sub primary_id{
   my ($self,$value) = @_;
   if( defined $value) {
      $self->{'primary_id'} = $value;
    }
    return $self->{'primary_id'};

}


=head2 comment

 Title   : comment
 Usage   : $self->comment($newval)
 Function: 
 Example : 
 Returns : value of comment
 Args    : newvalue (optional)


=cut

sub comment{
   my ($self,$value) = @_;
   if( defined $value) {
      $self->{'comment'} = $value;
    }
    return $self->{'comment'};

}
