
#
# BioPerl module for Bio::Annotation::Reference
#
# Cared for by Ewan Birney <pfam@sanger.ac.uk>
# Editied by Robert Finn 18/02/2002, put many more functions in
#
# Copyright Ewan Birney
#
# You may distribute this module under the same terms as perl itself

# POD documentation - main docs before the code

=head1 NAME

Bio::Annotation::Reference - DESCRIPTION of Object

=head1 SYNOPSIS

Give standard usage here

=head1 DESCRIPTION

Describe the object here

=head1 CONTACT

Describe contact details here

=head1 APPENDIX

The rest of the documentation details each of the object methods. Internal methods are usually preceded with a _

=cut


# Let the code begin...


package Bio::Annotation::Reference;
use vars qw($AUTOLOAD @ISA);
use strict;

# Object preamble - inheriets from Bio::Root::Object

use Bio::Root::Object;


@ISA = qw(Bio::Root::Object Exporter);
# new() is inherited from Bio::Root::Object

# _initialize is where the heavy stuff will happen when new is called

sub _initialize 
	{
	my($self,@args) = @_;
  	my $make = $self->SUPER::_initialize;
	# set stuff in self from @args
	return $make; # success - we hope!
	}


=head2 authors

 Title   : authors
 Usage   : $self->authors($newval)
 Function: 
 Example : 
 Returns : value of authors
 Args    : newvalue (optional)


=cut

sub authors
	{
   	my ($self,$value) = @_;
   	if( defined $value) 
		{
      		$self->{'authors'} = $value;
    		}
    	return $self->{'authors'};

	}

=head2 location

 Title   : location
 Usage   : $self->location($newval)
 Function: 
 Example : 
 Returns : value of location
 Args    : newvalue (optional)


=cut

sub location
	{
   	my ($self,$value) = @_;
   	if( defined $value) 
		{
      		$self->{'location'} = $value;
    		}
	return $self->{'location'};

	}

=head2 title

 Title   : title
 Usage   : $self->title($newval)
 Function: 
 Example : 
 Returns : value of title
 Args    : newvalue (optional)


=cut

sub title
	{
	my ($self,$value) = @_;
	
	if( defined $value) 
		{
      		$self->{'title'} = $value;
    		}
	return $self->{'title'};

	}

=head2 medline

 Title   : medline
 Usage   : $self->medline($newval)
 Function: 
 Example : 
 Returns : value of medline
 Args    : newvalue (optional)


=cut

sub medline
	{
	my ($self,$value) = @_;
   	if( defined $value) 
		{
	        $self->{'medline'} = $value;
    		}
    	return $self->{'medline'};
}

=head2 comment

 Title   : comment
 Usage   : $obj->comment($newval)
 Function: 
 Example : 
 Returns : value of comment
 Args    : newvalue (optional)


=cut

sub comment
	{
	my ($self ,$value) = @_;
 	if( defined $value) 
		{
      		$self->{'comment'} = $value;
    		}
    	return $self->{'comment'};
	}

=head2 abstract

 Title   : abstract
 Usage   : $obj->abstract($newval)
 Function: 
 Example : 
 Returns : value of journal
 Args    : newvalue (optional)

=cut

sub abstract 
	{
	my ($self, $value) = @_;
	if (defined $value)
		{
		$self->{'abstract'} = $value;
		}
	return $self->{'abstract'};
	}


=head2 journal

 Title   : journal
 Usage   : $obj->journal($newval)
 Function: 
 Example : 
 Returns : value of journal
 Args    : newvalue (optional)
	
=cut

sub journal
	{
	my ($self, $journal) = @_;
	if (defined $journal)
		{
		$self->{'journal'} = $journal;
		}

	return $self->{'journal'};
	}

=head2 volume

 Title   : volume
 Usage   : $obj->volume($newval)
 Function: 
 Example : 
 Returns : value of volume
 Args    : newvalue (optional)
	
=cut

sub volume
	{
	my ($self, $volume) = @_;
	if (defined $volume)
		{
		$self->{'volume'} = $volume;
		}

	return $self->{'volume'};
	}



=head2 pages

Title 	: pages
Usage 	: $obj->pages($start, $end);
Function: Get/Set the page numbers
Example	:
Returns	: @arry start = 0, end = 1
Args	: $start, $end (optional)

=cut

sub pages
	{
	my ($self, $start, $end) = @_;
	if (defined $start)
		{
		if (!defined $end)
			{
			$end = $start;
			}
		@_ = ($start,$end);
		@{$self->{'pages'}} = @_;
		}
	if (defined $self->{'pages'})
		{
		return $self->{'pages'};
		}
	}

=head2 pubmed

 Title   : pubmed
 Usage   : $refobj->pubmed($newval)
 Function: Get/Set the PubMed number, if it is different from the MedLine
           number.
 Example : 
 Returns : value of medline
 Args    : newvalue (optional)

=cut

sub pubmed 
	{
    	my ($self,$value) = @_;
    	if( defined $value) 
		{
		$self->{'pubmed'} = $value;
    		}
    	return $self->{'pubmed'};
	}	


=head2 date 

 Title    : date
 Usage	  : $obj->date(%newdate)
 Function : get/set the publication date 
 Example  : 
 Returns  : hash containing date, keys should be day, month, year
 Args     : newdate (optional)

=cut

sub date
	{
	my ($self) = shift;
	my $date = shift;
	if ($date)
		{
		$self->{'date'} = $date;
		}
	return $self->{'date'};
	}

sub author_list
	{
	my ($self, $author) = @_;
	if (defined $author)
		{
		push(@{$self->{'author_list'}}, $author);
		}
	if (defined $self->{'author_list'})
		{
		return @{$self->{'author_list'}};
		}
	}
sub type
	{
	my ($self, $type)= @_;
	if (defined $type)
		{
		$self->{'type'} = $type;
		}
	if (defined $self->{'type'})
		{
		return $self->{'type'};
		}
	else
		{
		return ("");
		}
	}
