
package Domain;

use vars qw($AUTOLOAD);

#@EXPORT = qw(&fromstring  &from_hmmls_string);


my %fields = (
    name  => undef,
    start => undef,
    end   => undef,
    bits  => undef,
    seq   => undef, # sequence - if there - test first 
    type  => undef # can be 'hmm' 'prosite-pat' 'prosite-prof' 
);

sub new {
    my $ref = shift;
    my $class = ref($ref) || $ref;
    
    my $self = {
	_permitted => \%fields,
	%fields, };
    bless $self, $class;
    return $self;
}

sub AUTOLOAD {
    my $self = shift;
    my $type = ref($self) || warn "Ok, $self is not an object of mine!";
    my $name = $AUTOLOAD;
    $name =~ s/.*://; #get only the bit we want
    unless (exists $self->{_permitted}->{$name} ) {
	warn "In type $type, can't access $name $keys  ";
    }
    if (@_) {
	return $self->{$name} = shift;
    } else {
	return $self->{$name}
    }
}


sub fromstring {
    my $self = shift;
    my $string = shift;

    my @names = split /:/, $string;
    $self->name(shift @names);
    $self->start(shift @names);
    $self->end(shift @names);
    
    return $self;
}

sub from_hmmls_string {
    my $self = shift;
    my $string = shift;
    
    if( !($string =~ /([0-9*\.[0-9]*)\s*\(bits\)\s*f:\s*([0-9]*)\s*t:\s*([0-9]*)\s*Target:.*/) ) {	       	
	warn("String [$string] does not match hmmls template");	
	return $self;		 
    }				
       $bits = $1;		
       $start = $2;
       $end = $3;

       $self->bits($bits);
       $self->start($start);
       $self->end($end);

       return $self;
				# 
}

sub from_hmmfs_string {
    my $self = shift;
    my $string = shift;
    
    if( !($string =~ /([0-9*\.[0-9]*)\s*([0-9]*)\s*([0-9]*).*/) ) {	       	
	warn("String [$string] does not match hmmfs template");	
	return $self;		 
    }				
       $bits = $1;		
       $start = $2;
       $end = $3;

       $self->bits($bits);
       $self->start($start);
       $self->end($end);

       return $self;
				# 
}


    
sub DESTROY {  }

END { }       # module clean-up code here (global destructor)

1;            # modules must return true

