
package DomainSet;

use PfamDatabase; # uses PfamModel
use Domain;
use Carp;
use GD;

use vars qw($AUTOLOAD);


my %fields = ( 
	      seqname  => undef,
	      length => undef,
	      domain => undef );

sub show_html {
    my $self = shift;
    my $file = shift;
    my $do_java= shift;
    my $dom;
    my $name;
    my @domarr;

    if( !$file) {
	carp("Attempting to make HTML output with no file stream... nope!");
	return 0;
    }
    $name = $self->seqname();

    print $file "Sequence $name - Domain organisation<p><CENTER><table  ALIGN=CENTER BORDER=5 CELLSPACING=0 CELLPADDING=5><tr ALIGN=CENTER><th>Domain</th><th>Start</th><th>End</th><th>Bits</th></tr>\n";
    
    @domarr = @{$self->domain()};
    
    $num = $#domarr;

    foreach $dom ( @domarr ) {
	print $file sprintf("<tr><td><a href=\"/Software/Pfam/RELEASE_2.0/%s.shtml\">%s</a></td><td ALIGN=RIGHT>%6d</td><td ALIGN=RIGHT>%6d</td><td ALIGN=RIGHT>%.2f</td></tr>\n",$dom->name(),$dom->name(),$dom->start(),$dom->end(),$dom->bits());
    }

    print $file "</table></CENTER>\n";
    
    
    if( $do_java == 1 ) {
	print $file "\n<p><CENTER><APPLET CODE=\"ImageViewer.Viewer\" CODEBASE=\"http://genome.wustl.edu/eddy/java/\" WIDTH = 200 HEIGHT = 30>\n";
	print $file sprintf("<PARAM NAME=\"DATA\" VALUE=\"%s %d %d ",$self->seqname(),$num,$self->length());
    
        @domarr = @{$self->domain()};


        foreach $dom ( @domarr ) {
	    print $file sprintf (" %s",$dom->name());
        }

        foreach $dom ( @domarr ) {
	    print $file sprintf (" %.2f",$dom->bits());
        }

        foreach $dom ( @domarr ) {
	    print $file sprintf (" %d",$dom->start());
        }

        foreach $dom ( @domarr ) {
	    print $file sprintf (" %d",$dom->end());
        }

        print $file "\"></APPLET></CENTER>\n";
    }
	


}
    
    
sub gif_string {
    my $self = shift;
    my $im;
    my $fac = 1;

    $im = new GD::Image(300,$fac*$self->length()+50);

#    $im = new GD::Image(100,100);

    $white = $im->colorAllocate(255,255,255);
    $black = $im->colorAllocate(0,0,0);       
    $red = $im->colorAllocate(255,0,0);      
    $blue = $im->colorAllocate(0,0,255);

    $im->transparent($white);
    $im->interlaced('true');



    @domarr = @{$self->domain};

    $prev = 0;
    $top = $fac*$self->length();
    

    foreach $dom (@domarr ) {
	$name = $dom->name();
	
	print STDERR "$top $prev $name\n";
	# draw line connecting this

#	if( $prev == 0 ) {
#	    $im->line(50,$prev+20,50,($fac*$dom->start())+20,$red);
#	} else {
#	    $im->line(50,$prev+20,50,($fac*$dom->start())+20,$black);
#	}

	$im->filledRectangle(40,$prev+20,60,($fac*$dom->start())+20,$black);

	# draw rectangle for domain 

	$im->filledRectangle(25,($fac*$dom->start())+20,75,($fac*$dom->end())+20,$red);
	
	$im->string(gdLargeFont,100,20+($fac*($dom->start() + ($dom->end() - $dom->start())/2)),$name,$black);


	$prev = $fac*$dom->end();
    }

    $im->filledRectangle(40,$prev+20,60,($fac*$self->length())+20,$black);

    return $im->gif;
}
    

    
    
	

sub pfam_domain_structure {
    my $self = shift;
    my $pfd  = shift; # pfam database
    my $seqfile = shift;
    my $monitor_r = shift;
    my $repfile = shift;
    my $num = 0;

    if( $monitor_r && $monitor_r > 0 ) {
	
    } else {
	$monitor_r = (-1);
    }

    my $pfm;
    my $domset;

    if( !(-e $seqfile) ) {
	carp("Sequence file $seqfile is does not exist, and so I am dubious about its sequence ;)");
	return 0;
    }

    foreach $pfm ( @{$pfd->{domain}} ) {
	if( ($monitor_r > 0) && ($num % $monitor_r) == 0 ) {
	    print $repfile sprintf("Searching domain $num [%s]\n",$pfm->name);
	}

	$domset = new DomainSet;
    
	$domset->pfam_model_domain($pfm,$seqfile);
	$self->add_DomainSet($domset);
	$num++;
    }

    return $self;
}

sub sort_by_start {
    my $self = shift;
    my @domarr;

    @domarr = @{$self->domain()};
 
    @domarr = sort {
	return ($a->start() <=> $b->start() );
    } @domarr;
    
    sort @domarr;

    $self->domain(\@domarr);
    return $self;
}
    

sub comp_two_domains_start  {
}


sub pfam_model_domain {
    my $self = shift;
    my $pfm  = shift; # pfam model
    my $seqfile = shift;
    my ($prog,$thresh,$hmmfile,$name,$num);
    
    $num = 0;
    $prog = $pfm->hmmprog();
    $thresh= $pfm->thresh();
    $hmmfile= $pfm->hmmfile();
    $name= $pfm->name();
    if( $pfm->random() == 1 ) {
	$rnd = sprintf(" -r %s ",$pfm->rndfile() );
    }else {
	$rnd = " ";
    }

#    print STDOUT "Opening with $prog -q -t $thresh $rnd $hmmfile $seqfile\n";

    if(  !(open (HMMLSPIPE,"$prog -q -t $thresh $rnd $hmmfile $seqfile |")) ) {
	carp("Could not open the hmmls pipe [$prog -q -t $thresh $hmmfile $temporary_seq$$] $!");
	return 0;
    }

    while (<HMMLSPIPE>) {
	chop;
#	print STDOUT "Found [$_]\n";

	if( !/^[0-9]/ ) {
	    next;
	}

	$dom = new Domain;
	if( $prog eq "hmmls") {
	    $dom->from_hmmls_string($_);
	} elsif ( $prog eq "hmmfs") {
	    $dom->from_hmmfs_string($_);
	} else {
	    carp("For Pfam Model $name, we have no program implementation");
	}

	$dom->name($name);

#	print STDERR sprintf("Got a domain with %s %d-%d\n",$dom->name,$dom->start,$dom->end);

	add_Domain($self,$dom);
	$num++
    }

    close(HMMLSPIPE);

    if( $? ) {
	print "!! Problem - Script failed with status $? from domain model $name<p>\n";
	carp "Ok, just to force that point: the script failed on domain model $name\n";
    }

    return $num;
}


    

sub new {
    my $ref = shift;
    my $class = ref($ref) || $ref;
    
    my $self = {
	_permitted => \%fields,
	%fields, };

    $self->{domain} = [];

    bless $self, $class;
    return $self;
}

sub show {
    my $self = shift;
    my $file = shift;
    my $dom;

    foreach $dom ( @{$self->domain()} ) {
	print $file sprintf("Domain %s [%d-%d] Bits %.2f\n",$dom->name(),$dom->start(),$dom->end(),$dom->bits());
    }
}

sub add_DomainSet {
    my $self = shift;
    my $doms = shift;
    my $dom;

    foreach $dom ( @{$doms->domain()} ) {
	add_Domain($self,$dom);
    }
    
    return $self;
}
    

sub add_Domain {
    my $self = shift;
    
    push(@{$self->{domain}},shift);
   
    return $self;
}

$hmmls_prog = "hmmls";

sub add_Domains_from_hmmls {
    my $self = shift;
    my $seqfile  = shift;
    my $hmmfile = shift;
    my $thresh = shift;
    my $dom;
    my $num = 0;
    
    if( !$thresh ) {
	$thresh = "15";
    }

    my $name = $hmmfile;
    $name =~ s/\..*$//g;
   
    if( !(open (HMMLSPIPE,"$hmmls_prog -q -t $thresh $hmmfile $seqfile |")) ) {
	carp("Could not open the hmmls pipe [$hmmls_prog -q -t $thresh $hmmfile $temporary_seq$$] $!");
	return 0;
    }

    while (<HMMLSPIPE>) {
	if( !/^[0-9]/ ) {
	    next;
	}

	$dom = new Domain;
	$dom->from_hmmls_string($_);

	$dom->name($name);

	add_Domain($self,$dom);
	$num++;
    }

    close(HMMLSPIPE);

    return $num;
}

sub AUTOLOAD {
    my $self = shift;
    my $type = ref($self) || warn "Ok, $self is not an object of mine!";
    my $name = $AUTOLOAD;
    $name =~ s/.*://; #get only the bit we want
    unless (exists $self->{_permitted}->{$name} ) {
	warn "In type $type, can't access $name $keys  ";
    }
    if (@_) {
	return $self->{$name} = shift;
    } else {
	return $self->{$name}
    }
}




    
sub DESTROY {  }

END { }       # module clean-up code here (global destructor)

1;            # modules must return true

