
package PfamDatabase;

use PfamModel;
use Carp;
use vars qw($AUTOLOAD);

#@EXPORT = qw(&fromstring  &from_hmmls_string);


my %fields = ( 
	      release  => undef,
	      domain => [],
	      );

sub getstd_release_subset {
    my $self = shift;
    my @wanted = @_;
    my $name;
    my $rel_dir;
    my $wstring;

    $wstring = join ':', @wanted;
    


    $rel_dir = $PfamModel::release_dir;



    if( !open(HMM,"$rel_dir/HMMs") ) {
	carp("Could not open the file $release_dir/HMMs");
	return 0;
    }

    while(<HMM>) {
	!/^(\S+)\s/ && next;
	
	$name = $1;
	if( !($wstring =~ /$name/) ) { next; }


	$mod = new PfamModel;

	$mod->name($name);
	$mod->getstd_model();

	push(@{$self->domain()},$mod);
	$num++;
	
    }

    return $num;

}

sub get_current_families {
    my $current_dir;
    my @arr;

    $current_dir = $PfamModel::current_dir;

    if( !opendir(DIR,$current_dir) ) {
	carp("Could not open current_dir Really bad!");
	die;
    }

    $trash = readdir DIR;
    $trash = readdir DIR;

    @arr = readdir DIR;

    closedir(DIR);

    return @arr;
}

sub get_family_list {
    my @out;
    my $rel_dir;

    $rel_dir = $PfamModel::release_dir;



    if( !open(HMM,"$rel_dir/HMMs") ) {
	carp("Could not open the file $release_dir/HMMs");
	return 0;
    }

    while(<HMM>) {
	!/^(\S+)\s/ && next;

	$name = $1;
	push(@out,$name);
	
    }
    return @out;
}


sub compare_overlap_to_current {
    my $one = shift;
    my $report = shift;
    my @families;
    my @arry;
    my %hash;

    # use main ALIGN-ment.

    # build a hash of one on sequence names:

    foreach $seq ( $one->align()->eachSequence() ) {
	$hash{$seq->name()} .= sprintf("%d-%d:",$seq->start(),$seq->end());
    }

    #
    # get current families to loop over
    #

    @families = get_current_families();

    #
    # foreach family, foreach sequence, find if it is in other sequence.
    #

    foreach $family ( @families ) {
	$model = new PfamModel;
	$model->get_current_model($family);

	foreach $seq ( $model->align()->eachSequence() ) {
	    if( $hash{$seq->name()} ) {
		$_ = $hash{$seq->name()};
		chop; # trailing :
		@startstop = split(/:/);
		foreach $startstop ( @startstop) {
		    ($start,$stop) = split(/-/,$startstop);
		    if( ($start >= $seq->start() && $stop <= $seq->end()) || 
		        ($start <= $seq->end() && $stop >= $seq->end()) ||  
		        ($start <= $seq->start && $stop >= $seq->start()) ) {
			push(@arry,sprintf("%s:%s/%d-%d:%s/%d-%d|",$seq->name(),$one->name(),$start,$stop,$model->name,$seq->start(),$seq->end()));
		    }
		}
	    }
	}
	if( $report ) {
	    print $report sprintf("Done Model %s",$model->name());
	}

	$model = undef; # free Model
    } # end of for each family

    return @arry;
}
    
sub getstd_release {
    my $self = shift;
    my $num = 0;
    my $name;
    my $rel_dir;

    $rel_dir = $PfamModel::release_dir;



    if( !open(HMM,"$rel_dir/HMMs") ) {
	carp("Could not open the file $release_dir/HMMs");
	return 0;
    }

    while(<HMM>) {
	!/^(\S+)\s/ && next;

	$name = $1;

	$mod = new PfamModel;

	$mod->name($name);
	$mod->getstd_model();

	push(@{$self->domain()},$mod);
	$num++;
	
    }

    return $num;




    $mod = new PfamModel;
    $mod->name("rrm");
    $mod->getstd_model();
    push(@{$self->domain()},$mod);

    return $self;
}

sub show {
    my $self = shift;
    my $file = shift;
    my $pm;


    print "Entring\n";

    foreach $pm ( @{$self->{domain}} ) {
	$pm->show($file);
    }
}
    
    
sub new {
    my $ref = shift;
    my $class = ref($ref) || $ref;
    
    my $self = {
	_permitted => \%fields,
	%fields, };

    $self->{domain} = [];

    bless $self, $class;
    return $self;
}



sub AUTOLOAD {
    my $self = shift;
    my $type = ref($self) || warn "Ok, $self is not an object of mine!";
    my $name = $AUTOLOAD;
    $name =~ s/.*://; #get only the bit we want
    unless (exists $self->{_permitted}->{$name} ) {
	warn "In type $type, can't access $name $keys  ";
    }
    if (@_) {
	return $self->{$name} = shift;
    } else {
	return $self->{$name}
    }
}

    
sub DESTROY {  }

END { }       # module clean-up code here (global destructor)


1;            # modules must return true


