

package Sequence;

use vars qw($AUTOLOAD);


my %fields = (
	      name  => undef,
	      seq => undef,
	      start => undef,
	      score => undef, 
	      end => undef,
);

sub new {
    my $ref = shift;
    my $class = ref($ref) || $ref;
    
    my $self = {
	_permitted => \%fields,
	%fields, };
    bless $self, $class;
    return $self;
}

sub AUTOLOAD {
    my $self = shift;
    my $type = ref($self) || warn "Ok, $self is not an object of mine!";
    my $name = $AUTOLOAD;
    $name =~ s/.*://; #get only the bit we want
    unless (exists $self->{_permitted}->{$name} ) {
	warn "In type $type, can't access $name $keys  ";
    }
    if (@_) {
	return $self->{$name} = shift;
    } else {
	return $self->{$name}
    }
}

sub DESTROY {
}

sub new_Sequence_from_string {
    my $name = shift;
    my $seq  = shift;
    my $out;


    if( !$seq ) {
	carp("Trying to make a new Sequence without a sequence!. Nope!");
	return undef;
    }
    
    $out = new Sequence;
    
    $out->name($name);
    $out->seq($seq);

    return $out;
}

sub truncate {
    my $self = shift;
    my $start = shift;
    my $end   = shift;

    $self->seq(substr($self->seq(),$start-1,$end-$start+1));

    $self->start($start);
    $self->end($end);

    return 1;
}

sub read_efetch_swiss34 {
    my $self = shift;
    my $name = shift;
    my $temp,$name,$line;

    open(EFETCH,"efetch -f -D /nfs/disk100/pubseq/swiss34/ $name|") || warn("Could not open efetch.");


    if( !($line = <EFETCH>) ) {
	return 0;
    }

    $line =~ /^>(\S+)\s/;

    $name = $1;
    $self->name($name);

    while( <EFETCH> ) {
	s/\W//g;
	$temp .= $_;
    }
    
    close(EFETCH);

    $self->seq($temp);

    return 1;
}
    

sub read_srs {
    my $self = shift;
    my $string = shift;

    open(GETZ,"getz -d '$string' |") || warn ("Could not open getz. Nope!");

    $line = <GETZ>;

    $line =~ /^>(\S+)\s/;

    $name = $1;
    $self->name($name);

    while( <GETZ> ) {
	s/\W//g;
	$temp .= $_;
    }

    close(GETZ);
    $self->seq($temp);

    return;
}
 

sub write_fasta {
    my $self = shift;
    my $file = shift;
    my $dostart = shift;
    my $name;
    my $seq,$count,$subseq;
    
    $name = $self->name();
    $seq  = $self->seq();

    if( $dostart) {
	print $file sprintf(">%s/%d-%d \n",$name,$self->start(),$self->end());
    } else {
	print $file ">$name\n";
    }

    $count =0;
    $length = length $seq;
    while( ($count * 60 ) < $length ) {
	$seqsub = substr($seq,$count*60,60);
	print $file "$seqsub\n";
	$count++;
    }

}






