


package SequenceSet;

use vars qw($AUTOLOAD);
use Sequence;

my %fields = (
	      set => undef # now a hash on name/start-end
);

sub new {
    my $ref = shift;
    my $class = ref($ref) || $ref;
    
    my $self = {
	_permitted => \%fields,
	%fields, };

    $self->{set} = {};

    bless $self, $class;
    return $self;
}

sub AUTOLOAD {
    my $self = shift;
    my $type = ref($self) || warn "Ok, $self is not an object of mine!";
    my $name = $AUTOLOAD;
    $name =~ s/.*://; #get only the bit we want
    unless (exists $self->{_permitted}->{$name} ) {
	warn "In type $type, can't access $name $keys  ";
    }
    if (@_) {
	return $self->{$name} = shift;
    } else {
	return $self->{$name}
    }
}

sub DESTROY {
}


sub eachSequence {
    my $self = shift;
    my @arr;
    my %hash;

    %hash = %{$self->set()};

    foreach $nse ( keys %hash ) {
	push(@arr,$hash{$nse});
    }

    return @arr;
}

sub addSequence {
    my $self = shift;
    my $seq  = shift;

    $self->{set}->{$seq->name()} = $seq;
}


sub read_hmmls_threshold {
    my $self = shift;
    my $in   = shift;
    my $thresh = shift;
    my $wing  = shift;


    while(<$in>) {
	!/(\d+.\d+).*f:\s+(\d+)\s+t:\s+(\d+)\s+Target:\s+(\S+)\s/ && next;

	$score = $1;
	$start = $2;
	$end   = $3;
	$name  = $4;

	
	if( defined $thresh && $score < $thresh ) {
	    next;
	}

	$seq = new Sequence;

	$seq->read_efetch_swiss34($name);

	# $seq->write_fasta(\*STDOUT);

	# print "Truncating at $start-$end for $name\n";

	if( $wing ) {
	    $start -= $wing;
	    if( $start < 1 ) {
		$start = 1;
	    }
	    $end += $wing;
	    if( $end > length($seq->seq()) ) {
		$end = length($seq->seq());
	    }
	}

	
	$seq->truncate($start,$end);
	$seq->score($score);

	# $seq->write_fasta(\*STDOUT);

	addSequence($self,$seq);
    }

    return $count;
}


    




