## Bioperl Test Harness Script for Modules

# Before `make install' is performed this script should be runnable with
# `make test'. After `make install' it should work as `perl test.t'

#-----------------------------------------------------------------------
## perl test harness expects the following output syntax only!
## 1..3
## ok 1  [not ok 1 (if test fails)]
## 2..3
## ok 2  [not ok 2 (if test fails)]
## 3..3
## ok 3  [not ok 3 (if test fails)]
##
## etc. etc. etc. (continue on for each tested function in the .t file)
#-----------------------------------------------------------------------


## We start with some black magic to print on failure.
BEGIN { $| = 1; print "1..9\n"; }
END {print "not ok 1\n" unless $loaded;}


use Bio::Pfam;

$loaded = 1;
print "ok 1\n";    # 1st test passes.


## End of black magic.
##
## Insert additional test code below but remember to change
## the print "1..x\n" in the BEGIN block to reflect the
## total number of tests that will be run. 

$db = &Bio::Pfam::default_db();

if( !defined $db ) { print "not ok 2\n"; }
else { print "ok 2\n"; }

$en = $db->get_EntryA_by_acc('PF00076');

if( !defined $en ) { print "not ok 3\n"; print STDERR "Cannot test rest of module.\n"; exit(1); }
else { print "ok 3\n"; }

$id = $en->id();
if( !defined $id ) { print "not ok 4\n"; }
else { print "ok 4\n"; }

$acc = $en->acc();
if( !defined $acc ) { print "not ok 5\n"; }
else { print "ok 5\n"; }

$author = $en->author();
if( !defined $author ) { print "not ok 6\n"; }
else { print "ok 6\n"; }

$ga = $en->gathering_cutoff();
if( !defined $ga ) { print "not ok 7\n"; }
else { print "ok 7\n"; }

$tc = $en->trusted_cutoff();
if( !defined $tc  ) { print "not ok 8\n"; }
else { print "ok 8\n"; }

$nc = $en->noise_cutoff();
if( !defined $nc ) { print "not ok 9\n"; }
else { print "ok 9\n"; }

